unit indice_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TformBibEv = class(TForm)
    buttonVaiPorra: TButton;
    Progress: TProgressBar;
    procedure FormCreate(Sender: TObject);
    procedure buttonVaiPorraClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formBibEv: TformBibEv;

implementation

{$R *.DFM}

procedure TformBibEv.FormCreate(Sender: TObject);
begin
  Caption := Application.Title;
end;

procedure TformBibEv.buttonVaiPorraClick(Sender: TObject);
var Indice : TStringList;
    Topico,Texto,TxtPath : String;
    Quit : boolean;
    F : TFileStream;
    I,J,K : Integer;
    C : PChar;
begin
  if MessageBox(0,'Isso demora p caraio! Vai mesmo???',PChar(Application.Title),MB_YESNO+MB_ICONQUESTION+MB_TASKMODAL+MB_DEFBUTTON2)=ID_NO then Halt;
  TxtPath := ExtractFilePath(Application.ExeName);
  SetLength(TxtPath,Length(TxtPath)-1);
  TxtPath := ExtractFilePath(TxtPath);
  Indice := TStringList.Create;
  Enabled := False;

  Caption := 'Bblia Catlica - Antigo Testamento';
  Indice.Clear;
  F := TFileStream.Create(TxtPath+'catolico\Antigo.htm',fmOpenRead or fmShareDenyWrite);
  GetMem(C,F.Size);
  F.Read(C^,F.Size);
  Texto := String(C);
  FreeMem(C);
  F.Free;
  Progress.Position := 0;
  Progress.Max := Length(Texto);
  K := 1;
  Quit := False;
  repeat
    I := pos('[',Texto);
    Texto := Copy(Texto,I+1,MaxInt);
    J := pos(']',Texto);
    Topico := Copy(Texto,1,J-1);
    Texto := Copy(Texto,J+1,MaxInt);
    K := K + I + J;
    J := pos('[',Texto)-1;
    if J=-1 then
    begin
      Quit := True;
      J := pos('</BODY>',Uppercase(Texto))-1;
    end;
    if J=-1 then J := Length(Texto);
    if Quit then Progress.Position := Progress.Max
    else Progress.Position := K+J;
    Application.ProcessMessages;
    Topico := Topico + '='+IntToStr(K)+'-'+IntToStr(J);
    Indice.Add(Topico);
  until Quit;
  Indice.SaveToFile(TxtPath+'catolico\Antigo.idx');

  Caption := 'Bblia Catlica - Novo Testamento';
  Indice.Clear;
  F := TFileStream.Create(TxtPath+'catolico\Novo.htm',fmOpenRead or fmShareDenyWrite);
  GetMem(C,F.Size);
  F.Read(C^,F.Size);
  Texto := String(C);
  FreeMem(C);
  F.Free;
  Progress.Position := 0;
  Progress.Max := Length(Texto);
  K := 1;
  Quit := False;
  repeat
    I := pos('[',Texto);
    Texto := Copy(Texto,I+1,MaxInt);
    J := pos(']',Texto);
    Topico := Copy(Texto,1,J-1);
    Texto := Copy(Texto,J+1,MaxInt);
    K := K + I + J;
    J := pos('[',Texto)-1;
    if J=-1 then
    begin
      Quit := True;
      J := pos('</BODY>',Uppercase(Texto))-1;
    end;
    if J=-1 then J := Length(Texto);
    if Quit then Progress.Position := Progress.Max
    else Progress.Position := K+J;
    Application.ProcessMessages;
    Topico := Topico + '='+IntToStr(K)+'-'+IntToStr(J);
    Indice.Add(Topico);
  until Quit;
  Indice.SaveToFile(TxtPath+'catolico\Novo.idx');

  Caption := 'Bblia Evanglica - Antigo Testamento';
  Indice.Clear;
  F := TFileStream.Create(TxtPath+'evangelico\Antigo.htm',fmOpenRead or fmShareDenyWrite);
  GetMem(C,F.Size);
  F.Read(C^,F.Size);
  Texto := String(C);
  FreeMem(C);
  F.Free;
  Progress.Position := 0;
  Progress.Max := Length(Texto);
  K := 1;
  Quit := False;
  repeat
    I := pos('[',Texto);
    Texto := Copy(Texto,I+1,MaxInt);
    J := pos(']',Texto);
    Topico := Copy(Texto,1,J-1);
    Texto := Copy(Texto,J+1,MaxInt);
    K := K + I + J;
    J := pos('[',Texto)-1;
    if J=-1 then
    begin
      Quit := True;
      J := pos('</BODY>',Uppercase(Texto))-1;
    end;
    if J=-1 then J := Length(Texto);
    if Quit then Progress.Position := Progress.Max
    else Progress.Position := K+J;
    Application.ProcessMessages;
    Topico := Topico + '='+IntToStr(K)+'-'+IntToStr(J);
    Indice.Add(Topico);
  until Quit;
  Indice.SaveToFile(TxtPath+'evangelico\Antigo.idx');

  Caption := 'Bblia Evanglica - Novo Testamento';
  Indice.Clear;
  F := TFileStream.Create(TxtPath+'evangelico\Novo.htm',fmOpenRead or fmShareDenyWrite);
  GetMem(C,F.Size);
  F.Read(C^,F.Size);
  Texto := String(C);
  FreeMem(C);
  F.Free;
  Progress.Position := 0;
  Progress.Max := Length(Texto);
  K := 1;
  Quit := False;
  repeat
    I := pos('[',Texto);
    Texto := Copy(Texto,I+1,MaxInt);
    J := pos(']',Texto);
    Topico := Copy(Texto,1,J-1);
    Texto := Copy(Texto,J+1,MaxInt);
    K := K + I + J;
    J := pos('[',Texto)-1;
    if J=-1 then
    begin
      Quit := True;
      J := pos('</BODY>',Uppercase(Texto))-1;
    end;
    if J=-1 then J := Length(Texto);
    if Quit then Progress.Position := Progress.Max
    else Progress.Position := K+J;
    Application.ProcessMessages;
    Topico := Topico + '='+IntToStr(K)+'-'+IntToStr(J);
    Indice.Add(Topico);
  until Quit;
  Indice.SaveToFile(TxtPath+'evangelico\Novo.idx');

  Caption := 'Bblia Judaica';
  Indice.Clear;
  F := TFileStream.Create(TxtPath+'Judeu\Tora.htm',fmOpenRead or fmShareDenyWrite);
  GetMem(C,F.Size);
  F.Read(C^,F.Size);
  Texto := String(C);
  FreeMem(C);
  F.Free;
  Progress.Position := 0;
  Progress.Max := Length(Texto);
  K := 1;
  Quit := False;
  repeat
    I := pos('[',Texto);
    Texto := Copy(Texto,I+1,MaxInt);
    J := pos(']',Texto);
    Topico := Copy(Texto,1,J-1);
    Texto := Copy(Texto,J+1,MaxInt);
    K := K + I + J;
    J := pos('[',Texto)-1;
    if J=-1 then
    begin
      Quit := True;
      J := pos('</BODY>',Uppercase(Texto))-1;
    end;
    if J=-1 then J := Length(Texto);
    if Quit then Progress.Position := Progress.Max
    else Progress.Position := K+J;
    Application.ProcessMessages;
    Topico := Topico + '='+IntToStr(K)+'-'+IntToStr(J);
    Indice.Add(Topico);
  until Quit;
  Indice.SaveToFile(TxtPath+'judeu\Tora.idx');

  Caption := 'Alcoro';
  Indice.Clear;
  F := TFileStream.Create(TxtPath+'muculmano\Alcorao.htm',fmOpenRead or fmShareDenyWrite);
  GetMem(C,F.Size);
  F.Read(C^,F.Size);
  Texto := String(C);
  FreeMem(C);
  F.Free;
  Progress.Position := 0;
  Progress.Max := Length(Texto);
  K := 1;
  Quit := False;
  repeat
    I := pos('[',Texto);
    Texto := Copy(Texto,I+1,MaxInt);
    J := pos(']',Texto);
    Topico := Copy(Texto,1,J-1);
    Texto := Copy(Texto,J+1,MaxInt);
    K := K + I + J;
    J := pos('[',Texto)-1;
    if J=-1 then
    begin
      Quit := True;
      J := pos('</BODY>',Uppercase(Texto))-1;
    end;
    if J=-1 then J := Length(Texto);
    if Quit then Progress.Position := Progress.Max
    else Progress.Position := K+J;
    Application.ProcessMessages;
    Topico := Topico + '='+IntToStr(K)+'-'+IntToStr(J);
    Indice.Add(Topico);
  until Quit;
  Indice.SaveToFile(TxtPath+'muculmano\Alcorao.idx');

  Caption := 'Evangelho Segundo o Espiritismo';
  Indice.Clear;
  F := TFileStream.Create(TxtPath+'espirita\evangelho.htm',fmOpenRead or fmShareDenyWrite);
  GetMem(C,F.Size);
  F.Read(C^,F.Size);
  Texto := String(C);
  FreeMem(C);
  F.Free;
  Progress.Position := 0;
  Progress.Max := Length(Texto);
  K := 1;
  Quit := False;
  repeat
    I := pos('[',Texto);
    Texto := Copy(Texto,I+1,MaxInt);
    J := pos(']',Texto);
    Topico := Copy(Texto,1,J-1);
    Texto := Copy(Texto,J+1,MaxInt);
    K := K + I + J;
    J := pos('[',Texto)-1;
    if J=-1 then
    begin
      Quit := True;
      J := pos('</BODY>',Uppercase(Texto))-1;
    end;
    if J=-1 then J := Length(Texto);
    if Quit then Progress.Position := Progress.Max
    else Progress.Position := K+J;
    Application.ProcessMessages;
    Topico := Topico + '='+IntToStr(K)+'-'+IntToStr(J);
    Indice.Add(Topico);
  until Quit;
  Indice.SaveToFile(TxtPath+'espirita\evangelho.idx');

  Enabled := True;
  Caption := Application.Title;
end;

end.
