unit bibcat_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TformBibCatHTM = class(TForm)
    Button1: TButton;
    RE: TRichEdit;
    Progress: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formBibCatHTM: TformBibCatHTM;

implementation

{$R *.DFM}

procedure TformBibCatHTM.Button1Click(Sender: TObject);
var Indice : TStringList;
    TChar,AChar,TxtPath,ITag,OTag,TextoI,TextoO : String;
    F : TFileStream;
    M : TMemoryStream;
    I,J,K : Integer;
    C : PChar;
    Numerou : Boolean;
    Pulou : Boolean;
begin
  if MessageBox(0,'Isso demora p caraio! Vai mesmo???',PChar(Application.Title),MB_YESNO+MB_ICONQUESTION+MB_TASKMODAL+MB_DEFBUTTON2)=ID_NO then Halt;
  TxtPath := ExtractFilePath(Application.ExeName);
  SetLength(TxtPath,Length(TxtPath)-1);
  TxtPath := ExtractFilePath(TxtPath)+'Catolico\';
  Enabled := False;
  //Antigo Testamento
  Indice := TStringList.Create;
  Indice.LoadFromFile(TxtPath+'IndiceAT.txt');
  M := TMemoryStream.Create;
  TextoO := '<html><body>';
  M := TMemoryStream.Create;
  For I := 1 to 46 do
  begin
    Caption := 'Antigo Testamento - '+IntToStr(I)+' de 46';
    if I<10 then F := TFileStream.Create(TxtPath+'p6t0'+IntToStr(I)+'.txt',fmOpenRead or fmShareDenyWrite)
    else F := TFileStream.Create(TxtPath+'p6t'+IntToStr(I)+'.txt',fmOpenRead or fmShareDenyWrite);
    GetMem(C,F.Size);
    F.Read(C^,F.Size);
    TextoI := String(C);
    Progress.Max := Length(TextoI);
    Progress.Step := Length(TextoI) div 20;
    F.Free;
    FreeMem(C);
    J := 1;
    OTag := '';
    Pulou := True;
    Numerou := False;
    repeat
      Progress.Position := J;
      if TextoI[J]='_' then
      begin
        Inc(J);
      end else
      if TextoI[J]='[' then
      begin
        repeat inc(J) until ((TextoI[J-1]=']') or (J=Length(TextoI)));
      end else
      if TextoI[J]='{' then
      begin
        ITag:='';
        repeat
          inc(j);
          ITag := ITag + AnsiUpperCase(TextoI[J]);
        until ((TextoI[J-1]='}') or (J=Length(TextoI)));
        SetLength(ITag,Length(ITag)-2);
        if ITag='N' then
        begin
          Numerou := False;
          if (not Pulou) then TextoO := TextoO + '<br>';
          TextoO := TextoO + '<br>';
          if K<0 then K := Length(TextoO);
          TextoO := TextoO + '<b>';
          OTag := '</b>' + OTag;
        end else
        if ITag='I' then
        begin
          Numerou := True;
          K := -1;
          TextoO := TextoO + '<br><b>';
          OTag := '. </b>' + OTag;
        end else
        if ITag='C' then
        begin
          if (not Pulou) and (not Numerou) then TextoO := TextoO + '<br><br>';
          if K<0 then K := Length(TextoO);
          if not Numerou then
          begin
            TextoO := TextoO + '<font size=+1><i><b>';
            OTag := '</b></i></font>' + OTag;
          end else
          begin
            TextoO := TextoO + '<i><b>';
            OTag := '</b></i>' + OTag;
            Numerou := False;
          end;
        end else
        if ITag='1' then
        begin
          Numerou := False;
          AChar := Indice[I-1]+' ';
          repeat
            AChar := AChar+TextoI[J];
            inc(J);
          until ((TextoI[J]='{') or (J=Length(TextoI)));
          if K>=0 then
          begin
            Insert('['+AChar+']',TextoO,K+1);
            TextoO := TextoO + '<br><br><font size=+2><b>'+AChar;
          end else
          begin
            TextoO := TextoO + '<br><br>['+AChar+']<font size=+2><b>'+AChar;
          end;
          OTag := '</b></font><br>' + OTag;
          K := -1;
        end else
        if ITag='/' then
        begin
          TextoO := TextoO + OTag;
          Pulou := pos('<br>',OTag)<>0;
          OTag := '';
        end;
      end else
      if Copy(TextoI,J,4)='\u00' then
      begin
        AChar := '{\rtf1\ansi\ansicpg1252 \'''+Copy(TextoI,J+4,2)+'}';
        M.Clear;
        C := PChar(AChar);
        M.Write(C^,Length(AChar));
        M.Position := 0;
        RE.Lines.LoadFromStream(M);
        Inc(J,6);
        TextoO := TextoO + RE.Text[1];
      end else
      if TextoI[J]=#13 then
      begin
        TextoO := TextoO + TextoI[J];
        Inc(J);
        Numerou := False;
      end else
      begin
        TextoO := TextoO + TextoI[J];
        Inc(J);
      end;
      if (J mod 20 = 0) or (J=Length(TextoI)) then Application.ProcessMessages;
    until J>=Length(TextoI);
    TextoO := TextoO + '<br>';
  end;
  TextoO := TextoO + '</body></html>';
  F := TFileStream.Create(TxtPath+'antigo.htm',fmCreate);
  C := PChar(TextoO);
  F.Write(C^,Length(TextoO));
  F.Free;
  Indice.Free;
  M.Free;


  //Novo Testamento
  Indice := TStringList.Create;
  Indice.LoadFromFile(TxtPath+'IndiceNT.txt');
  M := TMemoryStream.Create;
  TextoO := '<html><body>';
  M := TMemoryStream.Create;
  For I := 1 to 27 do
  begin
    Caption := 'Novo Testamento - '+IntToStr(I)+' de 27';
    F := TFileStream.Create(TxtPath+'p6t'+IntToStr(I+46)+'.txt',fmOpenRead or fmShareDenyWrite);
    GetMem(C,F.Size);
    F.Read(C^,F.Size);
    TextoI := String(C);
    Progress.Max := Length(TextoI);
    Progress.Step := Length(TextoI) div 20;
    F.Free;
    FreeMem(C);
    J := 1;
    OTag := '';
    Pulou := True;
    Numerou := False;
    repeat
      Progress.Position := J;
      if TextoI[J]='_' then
      begin
        Inc(J);
      end else
      if TextoI[J]='[' then
      begin
        repeat inc(J) until ((TextoI[J-1]=']') or (J=Length(TextoI)));
      end else
      if TextoI[J]='{' then
      begin
        ITag:='';
        repeat
          inc(j);
          ITag := ITag + AnsiUpperCase(TextoI[J]);
        until ((TextoI[J-1]='}') or (J=Length(TextoI)));
        SetLength(ITag,Length(ITag)-2);
        if ITag='N' then
        begin
          if (not Pulou) and (not Numerou) then TextoO := TextoO + '<br>';
          if not Numerou then TextoO := TextoO + '<br>';
          if K<0 then K := Length(TextoO);
          TextoO := TextoO + '<b>';
          OTag := '</b>' + OTag;
        end else
        if ITag='I' then
        begin
          K := -1;
          TextoO := TextoO + '<br><b>';
          OTag := '. </b>' + OTag;
        end else
        if ITag='C' then
        begin
          if (not Pulou) and (not Numerou) then TextoO := TextoO + '<br><br>';
          if K<0 then K := Length(TextoO);
          if not Numerou then
          begin
            TextoO := TextoO + '<font size=+1><i><b>';
            OTag := '</b></i></font>' + OTag;
          end else
          begin
            TextoO := TextoO + '<i><b>';
            OTag := '</b></i>' + OTag;
            Numerou := False;
          end;
        end else
        if ITag='1' then
        begin
          Numerou := True;
          AChar := Indice[I-1]+' ';
          repeat
            AChar := AChar+TextoI[J];
            inc(J);
          until ((TextoI[J]='{') or (J=Length(TextoI)));
          if K>=0 then
          begin
            Insert('['+AChar+']',TextoO,K+1);
            TextoO := TextoO + '<br><br><font size=+2><b>'+AChar;
          end else
          begin
            TextoO := TextoO + '<br><br>['+AChar+']<font size=+2><b>'+AChar;
          end;
          OTag := '</b></font><br>' + OTag;
          K := -1;
        end else
        if ITag='/' then
        begin
          TextoO := TextoO + OTag;
          Pulou := pos('<br>',OTag)<>0;
          OTag := '';
        end;
      end else
      if Copy(TextoI,J,4)='\u00' then
      begin
        AChar := '{\rtf1\ansi\ansicpg1252 \'''+Copy(TextoI,J+4,2)+'}';
        M.Clear;
        C := PChar(AChar);
        M.Write(C^,Length(AChar));
        M.Position := 0;
        RE.Lines.LoadFromStream(M);
        Inc(J,6);
        TextoO := TextoO + RE.Text[1];
      end else
      begin
        Numerou := False;
        TextoO := TextoO + TextoI[J];
        Inc(J);
      end;
      if (J mod 20 = 0) or (J=Length(TextoI)) then Application.ProcessMessages;
    until J>=Length(TextoI);
    TextoO := TextoO + '<br>';
  end;
  TextoO := TextoO + '</body></html>';
  F := TFileStream.Create(TxtPath+'novo.htm',fmCreate);
  C := PChar(TextoO);
  F.Write(C^,Length(TextoO));
  F.Free;
  Indice.Free;
  M.Free;
  Caption := Application.Title;
  Enabled := True;
end;

procedure TformBibCatHTM.FormCreate(Sender: TObject);
begin
  Caption := Application.Title;
end;

end.
