unit bibev_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TformBibEv = class(TForm)
    buttonVaiPorra: TButton;
    procedure FormCreate(Sender: TObject);
    procedure buttonVaiPorraClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formBibEv: TformBibEv;

implementation

{$R *.DFM}

procedure TformBibEv.FormCreate(Sender: TObject);
begin
  Caption := Application.Title;
end;

procedure TformBibEv.buttonVaiPorraClick(Sender: TObject);
var Indice : TStringList;
    TxtPath,Tag,TextoI,TextoO : String;
    Pulou : Boolean;
    F : TFileStream;
    I,J,K : Integer;
    C : PChar;
begin
  if MessageBox(0,'Isso demora p caraio! Vai mesmo???',PChar(Application.Title),MB_YESNO+MB_ICONQUESTION+MB_TASKMODAL+MB_DEFBUTTON2)=ID_NO then Halt;
  TxtPath := ExtractFilePath(Application.ExeName);
  SetLength(TxtPath,Length(TxtPath)-1);
  TxtPath := ExtractFilePath(TxtPath)+'bibev\';
  //Antigo Testamento
  Caption := 'Antigo testamento...';
  Indice := TStringList.Create;
  Indice.LoadFromFile(TxtPath+'Antigo.idx');
  F := TFileStream.Create(TxtPath+'Antigo.dat',fmOpenRead or fmShareDenyWrite);
  GetMem(C,F.Size);
  F.Read(C^,F.Size);
  TextoI := String(C);
  FreeMem(C);
  F.Free;
  TextoO := '<html><body>';
  I := 1;
  J := 0;
  Pulou := True;
  repeat
    if Pulou then
    begin
      Pulou := False;
      Tag := '';
      repeat
        Tag := Tag + TextoI[I];
        Inc(I);
      until TextoI[I]=' ';
      K := 0;
      While K<Length(Tag) do
      begin
        Inc(K);
        if (not (Tag[K] in ['0'..'9'])) then
        begin
          K := 0;
          Break;
        end;
      end;
      if K>0 then
      begin
        if StrToInt(Tag)=1 then
        begin
          Tag := '['+Copy(Indice[J],1,pos('#',Indice[J])-1)+']<font size=+2><b>'+Copy(Indice[J],1,pos('#',Indice[J])-1)+'</b></font><br><br><b>'+Tag+'.</b>'#13#10;
          if TextoO<>'<html><body>' then Tag := '<br>' + Tag + #13#10;
          Inc(J);
        end else Tag := '<b>'+Tag+'.</b>';
      end;
      TextoO := TextoO + Tag;
    end else
    if Copy(TextoI,I,2)=#13#10 then
    begin
      TextoO := TextoO + '<br>'#13#10;
      Inc(I,2);
      Pulou := True;
    end else
    begin
      TextoO := TextoO + TextoI[I];
      Inc(I);
    end;
  until I>=Length(TextoI);
  TextoO := TextoO + '</body></html>';
  C := PChar(TextoO);
  F := TFileStream.Create(TxtPath+'antigo.htm',fmCreate);
  F.Write(C^,Length(TextoO));
  F.Free;


  //Novo Testamento
  Caption := 'Novo testamento...';
  Indice := TStringList.Create;
  Indice.LoadFromFile(TxtPath+'Novo.idx');
  F := TFileStream.Create(TxtPath+'Novo.dat',fmOpenRead or fmShareDenyWrite);
  GetMem(C,F.Size);
  F.Read(C^,F.Size);
  TextoI := String(C);
  FreeMem(C);
  F.Free;
  TextoO := '<html><body>';
  I := 1;
  J := 0;
  Pulou := True;
  repeat
    if Pulou then
    begin
      Pulou := False;
      Tag := '';
      repeat
        Tag := Tag + TextoI[I];
        Inc(I);
      until TextoI[I]=' ';
      K := 0;
      While K<Length(Tag) do
      begin
        Inc(K);
        if (not (Tag[K] in ['0'..'9'])) then
        begin
          K := 0;
          Break;
        end;
      end;
      if K>0 then
      begin
        if StrToInt(Tag)=1 then
        begin
          Tag := '['+Copy(Indice[J],1,pos('#',Indice[J])-1)+']<font size=+2><b>'+Copy(Indice[J],1,pos('#',Indice[J])-1)+'</b></font><br><br><b>'+Tag+'.</b>'#13#10;
          if TextoO<>'<html><body>' then Tag := '<br>' + Tag + #13#10;
          Inc(J);
        end else Tag := '<b>'+Tag+'.</b>';
      end;
      TextoO := TextoO + Tag;
    end else
    if Copy(TextoI,I,2)=#13#10 then
    begin
      TextoO := TextoO + '<br>'#13#10;
      Inc(I,2);
      Pulou := True;
    end else
    begin
      TextoO := TextoO + TextoI[I];
      Inc(I);
    end;
  until I>=Length(TextoI);
  TextoO := TextoO + '</body></html>';
  C := PChar(TextoO);
  F := TFileStream.Create(TxtPath+'novo.htm',fmCreate);
  F.Write(C^,Length(TextoO));
  F.Free;

  Caption := Application.Title;
end;

end.
